package AccordionBus;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;

// Класс, отвечающий за прорисовку и перемещение объекта-сущности
public class DrawingAccordionBus extends DrawingBus {
    // Конструктор
    public DrawingAccordionBus(int speed, double weight, Color bodyColor, Color additionalColor, boolean additionalBody, boolean additionalDoor, int width, int height) {
        super(speed, weight, bodyColor, width, height, 215, 50);
        if (EntityBus != null) {
            EntityBus = new EntityAccordionBus(speed, weight, bodyColor, additionalColor, additionalBody, additionalDoor);
        }
    }

    // Прорисовка объекта
    public void DrawTransport(Graphics g) {
        if (EntityBus == null) {
            return;
        }

        Graphics2D g2d = (Graphics2D)g;

        super.DrawTransport(g2d);

        Color bodyColor = EntityBus.getBodyColor();
        Color additionalColor = ((EntityAccordionBus)EntityBus).getAdditionalColor();
        Color blackColor = Color.BLACK;
        Color whiteColor = Color.WHITE;


        // Дополнительный отсек
        if (((EntityAccordionBus)EntityBus).isAdditionalBody()) {
            // Граница дополнительного отсека
            g2d.setColor(blackColor);
            g2d.setStroke(new BasicStroke(3));
            g2d.drawRect(_startPosX + 115, _startPosY, 100, 40);

            // Кузов дополнительного отсека
            g2d.setColor(bodyColor);
            g2d.fillRect(_startPosX + 116, _startPosY + 1, 99, 39);

            // Окна главного отсека
            g2d.setColor(Color.CYAN);
            g2d.fillRect(_startPosX + 115, _startPosY + 5, 100, 15);
            g2d.setColor(blackColor);
            g2d.setStroke(new BasicStroke(2));
            g2d.drawLine(_startPosX + 115, _startPosY + 5, _startPosX + 215, _startPosY + 5);
            g2d.drawLine(_startPosX + 115, _startPosY + 20, _startPosX + 215, _startPosY + 20);

            // Дверь дополнительного отсека
            if (((EntityAccordionBus)EntityBus).isAdditionalDoor()) {
                g2d.setColor(blackColor);
                g2d.setStroke(new BasicStroke(2));
                g2d.drawRect(_startPosX + 175, _startPosY + 10, 15, 30);
                g2d.setColor(whiteColor);
                g2d.fillRect(_startPosX + 176, _startPosY + 11, 14, 29);
            }

            // Гармошка
            g2d.setColor(blackColor);
            g2d.setStroke(new BasicStroke(2));
            for (int i = 0; i < 5; i++) {
                g2d.drawLine(_startPosX + 100 + i * 3, _startPosY, _startPosX + 100 + i * 3, _startPosY + 40);
            }
        }

        // Дополнительные двери
        drawingDoors.DrawDoors(g2d, additionalColor, ((EntityAccordionBus) EntityBus).isAdditionalBody(), _startPosX, _startPosY);

        // Колеса главного отсека
        g2d.setColor(blackColor);
        g2d.setStroke(new BasicStroke(3));
        g2d.drawOval(_startPosX + 15, _startPosY + 33, 15, 15);
        g2d.drawOval(_startPosX + 70, _startPosY + 33, 15, 15);
        g2d.setColor(whiteColor);
        g2d.fillOval(_startPosX + 15, _startPosY + 33, 15, 15);
        g2d.fillOval(_startPosX + 70, _startPosY + 33, 15, 15);

        // Колеса дополнительного отсека
        if (((EntityAccordionBus)EntityBus).isAdditionalBody()) {
            g2d.setColor(blackColor);
            g2d.drawOval(_startPosX + 130, _startPosY + 33, 15, 15);
            g2d.drawOval(_startPosX + 185, _startPosY + 33, 15, 15);
            g2d.setColor(whiteColor);
            g2d.fillOval(_startPosX + 131, _startPosY + 33, 15, 15);
            g2d.fillOval(_startPosX + 186, _startPosY + 33, 15, 15);
        }
    }
}
