package AccordionBus;

import java.awt.*;

// Класс, отвечающий за второй тип орнамента отрисовки дополнительных дверей
public class DrawingDoorsTypeTwo implements IDrawingDoors {
    private NumDoors numDoors;

    public void setNumDoors(int num) {
        for (NumDoors temp : numDoors.values()) {
            if (temp.getNumDoors() == num) {
                numDoors = temp;
                return;
            }
        }
    }

    public void DrawDoors(Graphics2D g2d, Color color, boolean isAdditionalBody, int _startPosX, int _startPosY) {
        int value = numDoors.getNumDoors();
        if (value >= 3) {
            g2d.setStroke(new BasicStroke(2));
            Polygon firstDoor = new Polygon(new int[] { _startPosX + 45, _startPosX + 50, _startPosX + 55, _startPosX + 55, _startPosX + 50, _startPosX + 45, _startPosX + 40, _startPosX + 40 },
                                            new int[] { _startPosY + 10, _startPosY + 10, _startPosY + 20, _startPosY + 30, _startPosY + 40, _startPosY + 40, _startPosY + 30, _startPosY + 20 },
                                            8);
            g2d.setColor(color);
            g2d.fillPolygon(firstDoor);
            g2d.setColor(Color.BLACK);
            g2d.drawPolygon(firstDoor);
        }
        if (value >= 4) {
            g2d.setColor(Color.BLACK);
            g2d.setStroke(new BasicStroke(2));
            Polygon secondDoor = new Polygon(new int[] { _startPosX + 80, _startPosX + 85, _startPosX + 90, _startPosX + 90, _startPosX + 85, _startPosX + 80, _startPosX + 75, _startPosX + 75 },
                    new int[] { _startPosY + 10, _startPosY + 10, _startPosY + 20, _startPosY + 30, _startPosY + 40, _startPosY + 40, _startPosY + 30, _startPosY + 20 },
                    8);
            g2d.setColor(color);
            g2d.fillPolygon(secondDoor);
            g2d.setColor(Color.BLACK);
            g2d.drawPolygon(secondDoor);
        }
        if (value >= 5 && isAdditionalBody) {
            g2d.setColor(Color.BLACK);
            g2d.setStroke(new BasicStroke(2));
            Polygon thirdDoor = new Polygon(new int[] { _startPosX + 150, _startPosX + 155, _startPosX + 160, _startPosX + 160, _startPosX + 155, _startPosX + 150, _startPosX + 145, _startPosX + 145 },
                    new int[] { _startPosY + 10, _startPosY + 10, _startPosY + 20, _startPosY + 30, _startPosY + 40, _startPosY + 40, _startPosY + 30, _startPosY + 20 },
                    8);
            g2d.setColor(color);
            g2d.fillPolygon(thirdDoor);
            g2d.setColor(Color.BLACK);
            g2d.drawPolygon(thirdDoor);
        }
    }
}
