package AccordionBus;

// Реализация интерфейса IMoveableObject для работы с объектом DrawingBus (паттерн Adapter)
public class DrawingObjectBus implements IMoveableObject {
    private DrawingBus _drawingBus = null;

    public DrawingObjectBus(DrawingBus drawingBus) {
        _drawingBus = drawingBus;
    }

    public ObjectParameters GetObjectPosition() {
        if (_drawingBus == null || _drawingBus.EntityBus == null) {
            return null;
        }
        return new ObjectParameters(_drawingBus.GetPosX(), _drawingBus.GetPosY(), _drawingBus.GetWidth(), _drawingBus.GetHeigth());
    }

    public int GetStep() { return (int)(_drawingBus.EntityBus.Step()); }

    public boolean CheckCanMove(DirectionType direction) { return _drawingBus.CanMove(direction); }

    public void MoveObject(DirectionType direction) { _drawingBus.MoveTransport(direction); }
}
