package AccordionBus;

// Стратегия перемещения объекта в правый нижний угол экрана
public class MoveToBorder extends AbstractStrategy {
    protected boolean IsTargetDestination() {
        var objParams = GetObjectParameters();
        if (objParams == null) {
            return false;
        }

        return objParams.RightBorder() <= FieldWidth &&
                objParams.RightBorder() + GetStep() >= FieldWidth &&
                objParams.DownBorder() <= FieldHeight &&
                objParams.DownBorder() + GetStep() >= FieldHeight;
    }

    protected void MoveToTarget() {
        var objParams = GetObjectParameters();
        if (objParams == null) {
            return;
        }

        var diffX = objParams.RightBorder() - FieldWidth;
        if (Math.abs(diffX) > GetStep()) {
            MoveRight();
        }

        var diffY = objParams.ObjectMiddleVertical() - FieldWidth;
        if (Math.abs(diffY) > GetStep()) {
            MoveDown();
        }
    }
}
